<!--登录界面-->
<template>
	<view class="normal-login-container">
		<view class="loginBg">
			<img class="logo"  src="/static/images/loginBg.png" mode="widthFix">
		</view>
		<view class="login-form-content">
			<view class="input-item flex align-center">
				<view class="login-icon">
					<img src="/static/images/user.png" alt="" srcset="" />
				</view>
				<input v-model="loginForm.username" class="input" type="text" placeholder="请输入账号" maxlength="30" />
			</view>
			<view class="input-item flex align-center">
				<view class="login-icon">
					<img src="/static/images/pass.png" alt="" srcset="" />
				</view>
				<input v-model="loginForm.password" type="password" class="input" placeholder="请输入密码" maxlength="20" />
			</view>
			<view class="input-item flex align-center" style="width: 60%;margin: 0px;" v-if="captchaEnabled">
				<view class="iconfont icon-code icon"></view>
				<input v-model="loginForm.code" type="number" class="input" placeholder="请输入验证码" maxlength="4" />
				<view class="login-code">
					<image :src="codeUrl" @click="getCode" class="login-code-img"></image>
				</view>
			</view>
			<view class="action-btn">
				<button @click="handleLogin" class="login-btn cu-btn block bg-blue lg round">登录</button>
			</view>

			<view class="reg text-center">
				<text class="text-grey1"></text>
				<text @click="changeBaseUrl" class="text-blue">IP端口设置</text>
			</view>
			<!-- <view class="xieyi text-center">
				<text class="text-grey1">登录即代表同意</text>
				<text @click="handleUserAgrement" class="text-blue">《用户协议》</text>
				<text @click="handlePrivacy" class="text-blue">《隐私协议》</text>
			</view> -->
		</view>

	</view>
</template>

<script>
	import {
		getCodeImg
	} from '@/api/login'

	export default {
		data() {
			return {
				codeUrl: "",
				//是否开启验证码
				captchaEnabled: getApp().globalData.config.captchaEnabled,
				// 用户注册开关
				register: false,
				globalConfig: getApp().globalData.config,
				loginForm: {
					username: "admin",
					password: "admin",
					code: "",
					uuid: ''
				}
			}
		},
		created() {
			if (this.captchaEnabled) {
				this.getCode()
			}
		},
		methods: {
			// 用户注册
			handleUserRegister() {
				this.$tab.redirectTo(`/pages/register`)
			},
			// 隐私协议
			handlePrivacy() {
				let site = this.globalConfig.appInfo.agreements[0]
				this.$tab.navigateTo(`/pages/common/webview/index?title=${site.title}&url=${site.url}`)
			},
			// 修改IP端口信息
			changeBaseUrl() {
				console.log("changeBaseUrl")
				this.$tab.redirectTo("/pages/changeBaseUrl")
				// this.$tab.redirectTo(``)
			},
			// 用户协议
			handleUserAgrement() {
				let site = this.globalConfig.appInfo.agreements[1]
				this.$tab.navigateTo(`/pages/common/webview/index?title=${site.title}&url=${site.url}`)
			},
			// 获取图形验证码
			getCode() {
				getCodeImg().then(res => {
					this.captchaEnabled = res.captchaEnabled === undefined ? true : res.captchaEnabled
					if (this.captchaEnabled) {
						this.codeUrl = 'data:image/gif;base64,' + res.img
						this.loginForm.uuid = res.uuid
					}
				})
			},
			// 登录方法
			async handleLogin() {
				if (this.loginForm.username === "") {
					this.$modal.msgError("请输入您的账号")
				} else if (this.loginForm.password === "") {
					this.$modal.msgError("请输入您的密码")
				} else if (this.loginForm.code === "" && this.captchaEnabled) {
					this.$modal.msgError("请输入验证码")
				} else {
					this.$modal.loading("登录中，请耐心等待...")
					this.pwdLogin()
				}
			},
			// 密码登录
			async pwdLogin() {
				this.$store.dispatch('Login', this.loginForm).then(() => {
					this.$modal.closeLoading()
					this.loginSuccess()
				}).catch(() => {
					if (this.captchaEnabled) {
						console.log("pwdLogin")
						// this.getCode()
					}
				})
			},
			// 登录成功后，处理函数
			loginSuccess(result) {
				//1.获取用户信息并设置缓存
				//2.获取路由信息
				//3.获取权限信息
				//4.页面跳转到登录页
				this.$store.dispatch('GetInfo').then(() => {
					this.$store.dispatch('addRoute').then(() => {
						this.$store.dispatch('addPower').then(() => {
							console.log("this.$store.state.user=",this.$store.state.user)
							console.log("登录成功")
							this.$tab.reLaunch('/pages/work/index')
						})
					})
				
				})
			}
		}
	}
</script>

<style lang="scss">
	page {
		background-color: #ffffff;
	}
	.loginBg{
		position: absolute;
		top: 0;
		left: 0;
		width: 100%;
	}
	.logo {
		width: 100%;
		height:700rpx;
		opacity: 0.66;
	}

	.head {
		width: 300px;
		font-size: 30px !important;
		font-weight: 700 !important;
		margin-left: 20px !important;
		line-height: 60px !important;
		margin-top: 10px !important;
		position: absolute !important;
		display: inline-block !important;
		height: 60px !important;
		color: #36b368;
	}

	.normal-login-container {
		width: 100%;
		height: 100vh;
		overflow: hidden;
		.logo-content {
			width: 100%;
			font-size: 21px;
			text-align: center;
			padding-top: 15%;

			image {
				border-radius: 4px;
			}

			.title {
				margin-left: 10px;
			}
		}

		.login-form-content {
			text-align: center;
			margin: 20px auto;
			margin-top: 400px;
			width: 80%;

			.input-item {
				width: 606rpx;
				height: 100rpx;
				margin: 36rpx auto;
				border-radius: 24rpx;
				box-shadow: 0px 1rpx 5rpx 0px rgba(4, 8, 43, 0.04);
				/* #F7F8FA_禁用浅色1 */
				background: rgb(247, 248, 250);
				padding-left: 42rpx;
				.login-icon{
					width: 52rpx;
					height: 52rpx;
					img{
						width: 52rpx;
						height: 52rpx;
					}
				}
				.icon {
					font-size: 38rpx;
					margin-left: 10px;
					color: #999;
				}

				.input {
					width: 100%;
					font-size: 14px;
					line-height: 20px;
					text-align: left;
					padding-left: 15px;
				}

			}

			.login-btn {
				margin-top: 40px;
				height: 45px;
				border-radius: 24rpx;
				
				box-shadow: 0px 1rpx 5rpx 0px rgba(4, 8, 43, 0.04);
				/* #165DFF_主色 */
				background: rgb(22, 93, 255);
			}

			.reg {
				margin-top: 15px;
			}

			.xieyi {
				color: #333;
				margin-top: 20px;
			}

			.login-code {
				height: 38px;
				float: right;

				.login-code-img {
					height: 38px;
					position: absolute;
					margin-left: 10px;
					width: 200rpx;
				}
			}
		}
	}
</style>